security:
    enable_authenticator_manager: true
    # https://symfony.com/doc/current/security.html#registering-the-user-hashing-passwords
    password_hashers:
        Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface: 'auto'
    # https://symfony.com/doc/current/security.html#loading-the-user-the-user-provider
    providers:
        # used to reload user from session & other features (e.g. switch_user)
        app_user_provider:
            entity:
                class: App\Entity\User
                property: email
    firewalls:
        dev:
            pattern: ^/(_(profiler|wdt)|css|images|js)/
            security: false

#        main:
#            lazy: true
#            provider: app_user_provider

        login:
            pattern: ^/api/login
            stateless: true
            json_login:
                check_path: api_login
                success_handler: lexik_jwt_authentication.handler.authentication_success
                failure_handler: lexik_jwt_authentication.handler.authentication_failure

        logout:
            pattern: ^/api/logout
        admin:
            pattern: /(admin|debug)
            custom_authenticator: App\Security\AdminAuthenticator
            logout:
                path: admin_logout
                target: admin_login

        refresh_token:
            pattern: ^/api/token/refresh
            stateless: true
            refresh_jwt: ~

        api:
            pattern: ^/api
            stateless: true
            entry_point: jwt
            jwt: ~

    access_control:
        # allow unauthenticated users to access the login form
        - { path: ^/api/login, roles: PUBLIC_ACCESS }
        - { path: ^/api/register, roles: PUBLIC_ACCESS }
        - { path: ^/api/user/validate, roles: PUBLIC_ACCESS }
        - { path: ^/api/user/checkGoogle, roles: PUBLIC_ACCESS }
        - { path: ^/api/verify/email, roles: PUBLIC_ACCESS }
        - { path: ^/api/user/debug-twig, roles: PUBLIC_ACCESS }
        - { path: ^/admin/forgot-password, roles: PUBLIC_ACCESS }
        - { path: ^/admin/(en|fr)/login, roles: PUBLIC_ACCESS }
        - { path: ^/admin/(en|fr)/forgot-password, roles: PUBLIC_ACCESS }
        - { path: ^/admin/reset-password, roles: PUBLIC_ACCESS }
        - { path: ^/admin/stripe-webhooks, roles: PUBLIC_ACCESS }
        - { path: ^/api/token/refresh, roles: PUBLIC_ACCESS }

        # require to be authenticated to access others routes *
        - { path: ^/api/, roles: IS_AUTHENTICATED }
        - { path: ^/admin, roles: ROLE_ADMIN }
    role_hierarchy:
        # ROLE_ADMIN will also be considered as ROLE_USER
        ROLE_ADMIN: ROLE_USER
        ROLE_SUPER_ADMIN: [ ROLE_ADMIN, ROLE_ALLOWED_TO_SWITCH ]

when@test:
    security:
        password_hashers:
            # By default, password hashers are resource intensive and take time. This is
            # important to generate secure password hashes. In tests however, secure hashes
            # are not important, waste resources and increase test times. The following
            # reduces the work factor to the lowest possible values.
            Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface:
                algorithm: auto
                cost: 4 # Lowest possible value for bcrypt
                time_cost: 3 # Lowest possible value for argon
                memory_cost: 10 # Lowest possible value for argon
